{
 This unit contains two sample objects for stroring in RVF documents,
 in DocProperties collection.

 TSampleDocObject1 contains properties:
 - Thumbnail: TPicture

 TSampleDocObject2 contains properties:
 - Signature: String
 - Date: TDateTime

 Of course, we could use a single object to store all these properties.
 But we want to show that DocProperties can contain objects of different
 classes.


}

unit SampleDocObject;

interface

uses
  Graphics, Classes,
  RVDocParams;

type
  TSampleDocObject1 = class (TRVDocObject)
  private
    FThumbnail: TPicture;
    procedure SetThumbnail(const Value: TPicture);
  public
    constructor Create(ACollection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
  published
    property Thumbnail: TPicture read FThumbnail write SetThumbnail;
  end;

  TSampleDocObject2 = class (TRVDocObject)
  private
    FSignature: String;
    FDate: TDateTime;
  public
    procedure Assign(Source: TPersistent); override;
  published
    property Signature: String read FSignature write FSignature;
    property Date: TDateTime read FDate write FDate;
  end;

implementation

{ TSampleDocObject1 }

constructor TSampleDocObject1.Create(ACollection: TCollection);
begin
  inherited;
  FThumbnail := TPicture.Create;
end;

destructor TSampleDocObject1.Destroy;
begin
  FThumbnail.Free;
  inherited;
end;

procedure TSampleDocObject1.Assign(Source: TPersistent);
begin
  if Source is TSampleDocObject1 then
  begin
    Thumbnail := TSampleDocObject1(Source).Thumbnail;
  end
  else
    inherited;
end;

procedure TSampleDocObject1.SetThumbnail(const Value: TPicture);
begin
  FThumbnail.Assign(Value);
end;

{ TSampleDocObject2 }

procedure TSampleDocObject2.Assign(Source: TPersistent);
begin
  if Source is TSampleDocObject2 then
  begin
    Signature := TSampleDocObject2(Source).Signature;
    Date      := TSampleDocObject2(Source).Date;
  end
  else
    inherited;
end;

initialization

  RegisterClasses([TSampleDocObject1, TSampleDocObject2]);

end.
