unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RVStyle, RVScroll, RichView, RVEdit, jpeg, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    Image2: TImage;
    RichViewEdit2: TRichViewEdit;
    RVStyle2: TRVStyle;
    Button1: TButton;
    LabelS: TLabel;
    LabelD: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure CreateSampleDocument;
  end;

var
  Form1: TForm1;

implementation

uses
  SampleDocObject;

{$R *.dfm}

procedure TForm1.CreateSampleDocument;
var
  DocObject1: TSampleDocObject1;
  DocObject2: TSampleDocObject2;
begin
  RichViewEdit1.Clear;
  DocObject1 := TSampleDocObject1.Create(RichViewEdit1.DocObjects);
  DocObject1.Thumbnail := Image1.Picture;
  DocObject2 := TSampleDocObject2.Create(RichViewEdit1.DocObjects);
  DocObject2.Signature := 'It''s me!';
  DocObject2.Date := Date;
  RichViewEdit1.AddNL('DocObjects Test', 1, 1);
  RichViewEdit1.AddNL('This document contains two invisible objects.' +
   'Object1 includes a picture. Object2 includes a text and a date. ' +
   'Click the button below to save this document in a stream, and load ' +
   'this stream in the second editor', 0, 0);
  RichViewEdit1.Format;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CreateSampleDocument;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Stream: TMemoryStream;
  i: Integer;
begin
  // copying from RichViewEdit1 to RichViewEdit2
  Stream := TMemoryStream.Create;
  RichViewEdit1.SaveRVFToStream(Stream, False);
  Stream.Position := 0;
  RichViewEdit2.LoadRVFFromStream(Stream);
  RichViewEdit2.Format;
  // showing DocObjects from RichViewEdit2
  Image2.Picture := nil;
  LabelS.Caption := 'Signature:';
  LabelD.Caption := 'Date:';
  for i := 0 to RichViewEdit2.DocObjects.Count - 1 do
    if RichViewEdit2.DocObjects.Items[i] is TSampleDocObject1 then
      Image2.Picture := TSampleDocObject1(RichViewEdit2.DocObjects.Items[i]).Thumbnail
    else if RichViewEdit2.DocObjects.Items[i] is TSampleDocObject2 then
    begin
      LabelS.Caption := 'Signature: ' +
        TSampleDocObject2(RichViewEdit2.DocObjects.Items[i]).Signature;
      LabelD.Caption := 'Date: ' +
        DateToStr(TSampleDocObject2(RichViewEdit2.DocObjects.Items[i]).Date);
    end;
end;

end.
